import java.util.Optional;
import java.util.concurrent.ThreadLocalRandom;
import java.util.function.BinaryOperator;
import java.util.function.Function;
import java.util.stream.Stream;

class Exo1 {

    static final int nbCells = 10_000_000;
    static final int nbCoresDefault = 2;
    static int N, seqOutput, par2Output, parNOutput;


    // QUESTION 1

    static <T,U> U mapReduceSequential(Function<T,U> f, BinaryOperator<U> plus, U zero, T []array){
        U res = zero;
        for(T t : array) res = plus.apply(res, f.apply(t));
        return res;
    }

    static <T> int nbItems(T []array){
        return mapReduceSequential( x -> 1 , (x,y) -> x+y, 0, array);
    }

    static String concat(String []array){
        return mapReduceSequential( x -> x , (x,y) -> x+y, "", array);
    }


    // QUESTION 2

    static int nbOccursSeq(Character []array, Character c){
        int res = 0;
        for(Character c2 : array) {
            if (c.equals(c2)) res++;
        }
        return res;
    }

    static int nbOccurs(Character []array, Character c){
    // TODO!
        return 0;
    }

    // QUESTION 3

    static double vecDistance(float []point1, float []point2){
        if (point1.length != point2.length) return -1;
        float res = 0;
        for(int i=0; i<point1.length; i++) 
            res += (point1[i] - point2[i])*(point1[i] - point2[i]);
        return Math.sqrt(res);
    }

    static Optional<float []> nearestNeighbor(float [][]array, float []point){
        Optional<float []> res = Optional.empty();
        for(float []point2 : array) {
            if (res.isEmpty() || vecDistance(point, point2) < vecDistance(point, res.get())) 
                res = Optional.of(point2);
        }
        return res;
    }

    static Optional<float []> nearestNeighborMapReduce(float [][]array, float []point){
        // TODO!
        return Optional.empty();
    }


    // QUESTION 4

    static <T,U> U mapReduceParallel2(Function<T,U> f, BinaryOperator<U> plus, U zero, T []array){
    // TODO!
        return zero;
    }

    static <T,U> U mapReduceParallelN(Function<T,U> f, BinaryOperator<U> plus, U zero, T []array){
        // TODO!
            return zero;
        }
    
    static int nbOccursParallel2(Character []array, Character c){
    // TODO!
        return 0;
    }

    static int nbOccursParallelN(Character []array, Character c){
    // TODO!
        return 0;
    }


    // QUESTION 5

    static <T,U> U mapReduceStream(Function<T,U> f, BinaryOperator<U> plus, U zero, Stream<T> s){
        // TODO!
        return zero;
    }

    public static void main(String []argv){
        N = getNbThreads(argv);
        Character []array = randomCharArray();
        Character c = randomChar();
        float seqTime = Chrono.run( () -> {
            seqOutput = nbOccurs(array, c);
        }); 
        System.out.printf("Résultat avec nbOccurs : %d\n", seqOutput);
        System.out.printf("Temps avec nbOccurs: %.2f\n", seqTime);
        float par2Time = Chrono.run( () -> {
            par2Output = nbOccursParallel2(array, c);
        }); 
        System.out.printf("Résultat avec nbOccursParallel2 : %d\n", par2Output);
        System.out.printf("Speedup avec nbOccursParallel2: %.2f\n", seqTime / par2Time);
        float parNTime = Chrono.run( () -> {
            parNOutput  = nbOccursParallelN(array, c);
        }); 
        System.out.printf("Résultat avec nbOccursParallelN : %d\n", parNOutput);
        System.out.printf("Speedup avec nbOccursParallelN (N=%d): %.2f\n", N, seqTime / parNTime);
    }


    static int getNbThreads(String []argv){
        try { return Integer.parseInt(argv[0]); }
        catch (Exception e) { return Runtime.getRuntime().availableProcessors();}
    }

    static Character randomChar(){
        ThreadLocalRandom rand = ThreadLocalRandom.current();
        return (char) rand.nextInt(256);
    }

    static Character []randomCharArray(){
        Character []res = new Character[nbCells];
        for(int i=0; i<nbCells; i++) res[i] = randomChar();
        return res;
    }
}